



typedef enum _VVDSType	{
	VVDSNone = -2,				//	reserved for describing the type of a NIL data source!
	VVDSDeleted = -1,				//	reserved for deleted
	VVDSBasic = 0,				//	basic- no value, sends off button notifications; momentary buttons use these
	VVDSFloatFrequent = 1,		//	val is set every iteration.  always visible in menus.
	VVDSFloatFreqNonRepeat = 2,	//	val is evaluated every proc (like frequent), but subscribed sliders/buttons only pinged if val has changed
	VVDSFloatInfrequent = 3,		//	val is set by something.  always visible in menus.  doesn't trigger on repeat values!
	VVDSFloatInfreqRepeat = 4,		//	same as VVDSFloatInfrequent, but repeat values are repeated.  NotesToVal and StepSequencer use these.
	VVDSFloatInfreqButton = 5,		//	val is set by something, always visible in menus- also sends off button notifications
	VVDSHolder = 6,				//	holder- contents are visible.
	VVDSInfrequentHolder = 7,		//	holder- contents don't get DSCProc, invisble in menus.
	VVDSInfreqVisHolder = 8,		//	holder- contents don't get DSCProc, but is visible in menus.
	VVDSColorHolder = 9,			//	holder- contents get DSCProc (they're frequent), and are visible in menus
	VVDSPointHolder = 10,			//	holder- contents get DSCProc (they're frequent), and are visible in menus
	
	VVDSALL = 11
} VVDSType;



