//
//  DSColorHolder.h
//  VDMX
//
//  Created by bagheera on 1/15/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DSCGlobals.h"
#import "DataSourceHolder.h"
#import "DSFloatFrequent.h"




@protocol DSColorHolderDelegateProtocol
- (float) rValForColorHolder:self;
- (float) gValForColorHolder:self;
- (float) bValForColorHolder:self;
- (float) hValForColorHolder:self;
- (float) sValForColorHolder:self;
- (float) vValForColorHolder:self;
@end




@interface DSColorHolder : DataSourceHolder {
	
	id					delegate;
	
	DSFloatFrequent		*r;
	DSFloatFrequent		*g;
	DSFloatFrequent		*b;
	//DSFloatFrequent		*h;
	//DSFloatFrequent		*s;
	//DSFloatFrequent		*v;
	
	float					rVal;
	float					gVal;
	float					bVal;
	//float					hVal;
	//float					sVal;
	//float					vVal;
}

+ (id) createWithName:(NSString *)n;
- (id) initWithName:(NSString *)n;

- (void) prepareToBeDeleted;

- (void) setParentSource:(DataSource *)np fromDSC:(id)dsc;
- (NSMutableArray *) extractMenuItemsToLevel:(int)level carryOverToLevel:(int)reset;
- (NSArray *) getDataSourcesMenuItems;

- (void) setDataSourceVal:(DSFloatFrequent *)ds;

- (void) setDelegate:(id)n;

@end
