//
//  FXChainDragDestBox.h
//  VVSliders
//
//  Created by bagheera on 2/8/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "FXChainManager.h"
@class FXChainManager;
//#import "FXObject.h"
//@class FXObject;
//#import "VVRedView.h"
//@class VVRedView;


@interface FXChainDragDestBox : NSBox {
	IBOutlet id				myChain;
	id					theHighlight;	//	instance of VVRedView class!
	long					dropInsertionLocation;	//	the index in the [myChain fxArray] at which the fx being dragged will be inserted.  if -1, don't do the drop.
	NSColor				*fillColor;
	id					dataSourceController;
}
- (NSView *) myView;
- (void) mouseDown:(NSEvent *)e;
- (unsigned int) draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int) draggingUpdated:(id <NSDraggingInfo>)sender;
- (void) draggingExited:(id <NSDraggingInfo>)sender;
- (BOOL) prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL) performDragOperation:(id <NSDraggingInfo>)sender;
- (void) concludeDragOperation:(id <NSDraggingInfo>)sender;

- (void) setDataSourceController:(id)n;

@end
