


@protocol FXChainManagerProtocol

- (int) depth;	//	returns the depth
- (BOOL) useSourceRes;
- (BOOL) groupFlag;
- (NSMutableArray *) layerArray;
- (void) setLayerName:(NSString *) newName;
- (NSString *) layerName;
- (id) parentLayer;
- (NSSize) layerSize;
- (id) compFilter;
- (void) useCompModeNamed:(NSString *)realCompName;
- (BOOL) containsThisLayer:(id)containsMe;

@end




@protocol ChainManagerDelegateProtocol

- (void) setChainManager:(id)n;
- (void) updateChainBasedLists;

@end





@protocol LayerChainManagerProtocol

- (void) setLayerChainManager:(id)n;

@end


