//
//  FXObjectPanel.h
//  NewFXTestApp
//
//  Created by bagheera on 12/12/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import "FXObject.h"
//@class FXObject;
#import "FXChainManager.h"
@class FXChainManager;
//#import "VVButton.h"
//@class VVButton;
//#import "VVButtonManager.h"
//@class VVButtonManager;
#import "DataSourceController.h"



@interface FXObjectPanel : NSView {
	//NSBezierPath			*collapseArrowPath;
	//NSBezierPath			*onOffDotPath;
	//NSBezierPath			*deleteButtonPath;
	id					bypassButton;
	IBOutlet id				myFXObject;
	NSMutableDictionary		*fontInfo;
	
	long					clickMask;		//	mask representing what user clicked on
	NSPoint				mouseDownClickLoc;	//	the local point where i clicked
	BOOL					optOnClick;
	
	//	images for drawing shit.  just pointers from the pluginResourceDict in my FXChainManager
	//NSImage				*onImg;
	//NSImage				*offImg;
	//NSImage				*resizeImg;
	NSImage				*deleteImg;
	//NSImage				*expandImg;
	//NSImage				*collapseImg;
	
	NSImage				*collapsedImage;
	NSImage				*expandedImage;
	//NSImage				*resizeImage;
	//	rects for the above images
	NSRect				onOffImgRect;
	//NSRect				resizeImgRect;
	NSRect				deleteImgRect;
	NSRect				expandCollapseImgRect;
	
	BOOL					collapsedFlag;
	BOOL					onFlag;
	//VVButtonManager		*buttonManager;
	DataSourceController	*dataSourceController;
}

- (void) prepareToBeDeleted;

- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent;
- (BOOL) isOpaque;
//- (void) renderInitialPaths	;
- (void) loadImagesFromManager;
- (void) updateImageLocationsWithSize:(NSSize)newSize;
- (FXObject *)myFXObject;
- (void) mouseDown:(NSEvent *)event;
- (void) mouseDragged:(NSEvent *)event;
- (void) pasteboard:(NSPasteboard *)sender provideDataForType:(NSString *)type;

//- (NSBezierPath *) roundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
//- (NSBezierPath *) halfRoundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;

- (void) forceRedrawNotification:(NSNotification *)note;

//- (VVButtonManager *) buttonManager;
//- (void) setButtonManager:(VVButtonManager *)n;

- (id) bypassButton;
- (BOOL) collapsedFlag;
- (void) setCollapsedFlag:(BOOL)n;
- (void) setDataSourceController:(id)n;
- (BOOL) optOnClick;


@end
