#ifndef _VVGLOBALKEYS
#define _VVGLOBALKEYS










//#import <AppKit/AppKit.h>
//#import <Quartz/Quartz.h>
//#import <QuartzCore/QuartzCore.h>
//#import <QuartzCore/CoreVideo.h>
//#import <QuartzComposer/QCRenderer.h>
//#import <CoreGraphics/CGDirectDisplay.h>
//#import <QTKit/QTKit.h>
//#import <Quicktime/Quicktime.h>
//#import <OpenGL/gl.h>
//#import <OpenGL/glext.h>
//#import <pthread.h>








//	nice little macro for strings
#define VVSTRING(n) ((NSString *)[NSString stringWithString:n])
#define VVFMTSTRING(f, ...) ((NSString *)[NSString stringWithFormat:f, ##__VA_ARGS__])

//	macros for quickly making arrays because.....well, it's the wiimote, and i'm fucking tired of typing.  so there.
#define OBJARRAY(f) [NSArray arrayWithObject:f]
#define OBJSARRAY(f, ...) [NSArray arrayWithObjects:f, ##__VA_ARGS__, nil]

//	macro for quickly making colors
#define VVCALCOLOR(r,g,b,a) [NSColor colorWithCalibratedRed:r green:g blue:b alpha:a]

//	macro for performing a bitmask and returning a BOOL
#define VVBITMASKCHECK(mask,flagToCheck) ((mask & flagToCheck) == flagToCheck) ? (BOOL)YES : (BOOL)NO








//#import "NSMutableArrayDSCAdditions.h"
#import "NSMutableArrayDSCAdditions.h"
#import "NSValueQTKitAdditions.h"
#import "NSMutDictAdditions.h"
#import "NSStringAdditions.h"
#import "NSAttributedStringAdditions.h"
#import "NSScrollerAdditions.h"
#import "AppControllerProtocol.h"
#import "CompositorProtocol.h"
#import "LayerProtocol.h"
#import "VidSourceProtocol.h"
#import "MasterClockProtocol.h"
#import "TapManagerProtocol.h"
#import "FXChainManagerProtocol.h"
#import "VVFileLoaderProtocol.h"
#import "VVSnapshotProtocol.h"
#import "ActiveDeleteDelegateProtocol.h"

#import "VVSliderDelegateProtocol.h"
#import "VVButtonDelegateProtocol.h"
#import "DataSourceProtocol.h"
#import "VVWindowDelegateProtocol.h"
#import "AltUIItemProtocol.h"

#import "VVRectHolder.h"
//#import "TheApplication.h"
#import "VVStatChecker.h"
#import "VVSafeString.h"
#import "StringTexture.h"
#import "MutableTextureObject.h"
#import "VVBezierPath.h"
#import "VVScrollVIew.h"














//	rounded-window stuff
#define WSOBMoveSetupNotification @"WSOBMoveSetupNotification"
#define WSOBMoveNotification @"WSOBMoveNotification"
#define WSOBCalculateAffectedAreaNotification @"WSOBCalculateAffectedAreaNotification"
#define WSOBMoveAffectedNotification @"WSOBMoveAffectedNotification"
#define WSOBWindowFocusNotification @"WSOBWindowFocusNotification"
#define WSOBSizePosReport @"WSOBSizePosReport"

//#define VVLayerWindowFileBGColorActive [NSColor colorWithCalibratedRed:0.75 green:0.75 blue:0.75 alpha:1.0]
//#define VVLayerWindowFileBGColorInactive [NSColor grayColor]









//	fired immediately after the app delegate (AppController) is sure that it's about to quit
#define AppAboutToQuitNotification @"AppAboutToQuitNotification"














//	slider stuff
#define VVSMNewSliderNotification @"VVSMNewSliderNotification"
#define VVSMDeleteSliderNotification @"VVSMDeleteSliderNotification"
//	slider change flags (signifies that the value is to be changed)
#define VVSliderChangeNone		0
#define VVSliderChangeValue		1
#define VVSliderChangeMinenv		2
#define VVSliderChangeMaxenv		4
#define VVSliderChangeIP			8
//	slider jump flags (did i click & drag on the handle, or if not, i just follow the mouse)
#define VVSliderJumpNone		0
#define VVSliderJumpValue		1
#define VVSliderJumpMinenv		2
#define VVSliderJumpMaxenv		4
//	slider colors; these are the names of keys in 'sliderColorDict'
//#define VVSliderModeNone @"VVSliderModeNone"	//	normal, click-drag-set mode
//#define VVSliderModeSynch @"VVSliderModeSynch"	//	synched to something
//#define VVSliderModeBehav @"VVSliderModeBehav"	//	using a behavior
//#define VVSliderModeWave @"VVSliderModeWave"	//	using a wave
#define VVSliderModeNoneActive @"VVSliderModeNoneActive"	//	normal, click-drag-set mode
#define VVSliderModeSynchActive @"VVSliderModeSynchActive"	//	synched to something
#define VVSliderModeBehavActive @"VVSliderModeBehavActive"	//	using a behavior
#define VVSliderModeWaveActive @"VVSliderModeWaveActive"	//	using a wave
#define VVSliderModeLearnActive @"VVSliderModeLearnActive"	//	in hardware learn mode

#define VVSliderModeNoneInactive @"VVSliderModeNoneInactive"	//	normal, click-drag-set mode
#define VVSliderModeSynchInactive @"VVSliderModeSynchInactive"	//	synched to something
#define VVSliderModeBehavInactive @"VVSliderModeBehavInactive"	//	using a behavior
#define VVSliderModeWaveInactive @"VVSliderModeWaveInactive"	//	using a wave
#define VVSliderModeLearnInactive @"VVSliderModeLearnInactive"	//	in hardware learn mode

//	when a behavior's name is changed, a notification has to be sent so the slider manager can update the sliders
#define VVSMBehaviorNameChangeNotification @"VVSMBehaviorNameChangeNotification"
//	when a behavior chain is deleted, a notification is posted so the slider manager can tell sliders using the behavior to stop doing so
#define VVSMBehaviorChainDeletedNotification @"VVSMBehaviorChainDeletedNotification"
//	some things just need to find the slider manager
#define VVSMFinderNotification @"VVSMFinderNotification"



//	the names under which actual colors are stored
#define VVSliderFrameColor @"VVSliderFrameColor"
#define VVSliderColorBG @"VVSliderColorBG"
#define VVSliderColor @"VVSliderColor"
#define VVSliderEnvColor @"VVSliderEnvColor"
#define VVSliderEnvHandleColor @"VVSliderEnvHandleColor"
#define VVSliderTextAttribs @"VVSliderTextAttribs"
#define VVSliderEnvTextAttribs @"VVSliderEnvTextAttribs"
#define VVSliderTextShadowAttribs @"VVSliderTextShadowAttribs"
#define VVSliderTrackColor @"VVSliderTrackColor"
#define VVSliderTrackShadowColor @"VVSliderTrackShadowColor"
//	macros for *cleanly* implementing locking in sliders
#define SLIDERLOCK1														\
	BOOL			considerLockedSliders = NO;									\
	BOOL			doLockedSliders = NO;										\
																		\
	if (hasLockedSliders || lockedFlag)											\
		considerLockedSliders = YES;											\
	doLockedSliders = [self okayToTriggerLockedSliders];							\
	if (doLockedSliders)	{													\
		if (hasLockedSliders)	{												\
			NSEnumerator		*sliderIt = [lockedSliderArray objectEnumerator];		\
			VVSliderCell		*sliderPtr;									\
			while (sliderPtr = [sliderIt nextObject])	{
				/*	call the method i'm in here...	*/
#define SLIDERLOCK2														\
			}															\
		}																\
		else if (lockedFlag)	{
			/*	call the method i'm in here...	*/
#define SLIDERLOCK3														\
		}																\
		pthread_mutex_unlock(&lockedSliderLock);								\
	}																	\
	if ((considerLockedSliders && doLockedSliders) || (!considerLockedSliders))	{		
		/*	this is where the actual code for doing whatever it is i'm supposed to be doing goes	*/
#define SLIDERLOCK4														\
	}







//	this is a macro for drawing an NSRect in opengl
#define GLDRAWRECT(r)											\
glBegin(GL_QUADS);												\
	glVertex2f(r.origin.x, r.origin.y);								\
	glVertex2f(r.origin.x, r.origin.y+r.size.height);					\
	glVertex2f(r.origin.x+r.size.width, r.origin.y+r.size.height);			\
	glVertex2f(r.origin.x+r.size.width, r.origin.y);						\
glEnd();


//	this is a macro for stroking an NSRect in opengl
#define GLSTROKERECT(r)											\
glBegin(GL_LINES);												\
	glVertex2f(r.origin.x, r.origin.y);								\
	glVertex2f(r.origin.x+r.size.width, r.origin.y);						\
glEnd();														\
glBegin(GL_LINES);												\
	glVertex2f(r.origin.x+r.size.width, r.origin.y);						\
	glVertex2f(r.origin.x+r.size.width, r.origin.y+r.size.height);			\
glEnd();														\
glBegin(GL_LINES);												\
	glVertex2f(r.origin.x+r.size.width, r.origin.y+r.size.height);			\
	glVertex2f(r.origin.x, r.origin.y+r.size.height);					\
glEnd();														\
glBegin(GL_LINES);												\
	glVertex2f(r.origin.x, r.origin.y+r.size.height);					\
	glVertex2f(r.origin.x, r.origin.y);								\
glEnd();

//	this is a macro for drawing a line connecting two points
#define GLDRAWLINE(p,q)											\
glBegin(GL_LINES);												\
	glVertex2f(p.x,p.y);											\
	glVertex2f(q.x,q.y);											\
glEnd();

//	this is a macro for drawing a diamond specified by a point and radius in opengl
#define GLDRAWDIAMOND(p,r)										\
glBegin(GL_QUADS);												\
	glVertex2f(p.x-r, p.y);										\
	glVertex2f(p.x,p.y+r);										\
	glVertex2f(p.x+r,p.y);										\
	glVertex2f(p.x,p.y-r);										\
glEnd();

//	this is a macro for stroking an diamond around a point in opengl
#define GLSTROKEDIAMOND(p,r)									\
glBegin(GL_LINES);												\
	glVertex2f(p.x-r, p.y);										\
	glVertex2f(p.x,p.y+r);										\
glEnd();														\
glBegin(GL_LINES);												\
	glVertex2f(p.x,p.y+r);										\
	glVertex2f(p.x+r,p.y);										\
glEnd();														\
glBegin(GL_LINES);												\
	glVertex2f(p.x+r,p.y);										\
	glVertex2f(p.x,p.y-r);										\
glEnd();														\
glBegin(GL_LINES);												\
	glVertex2f(p.x,p.y-r);										\
	glVertex2f(p.x-r, p.y);										\
glEnd();




//	when buttons are pushed, this notification gets fired
#define VVButtonDetectNotification @"VVButtonDetectNotification"
//	this is the string used to specify notifications used for detecting incoming midi data (slider, shortcuts, etc.)
#define VVMIDIDetectNotification @"VVMIDIDetectNotification"
//	this is the string used to specify notifications used for detecting incoming key data
#define VVKeyDetectNotification @"VVKeyDetectNotification"
//	this is the string used to specify notifications that are fired when there's incoming OSC data
#define VVOSCDetectNotification @"VVOSCDetectNotification"










//	name of the notification that's posted when a new button has been created (it needs to find the button manager)
#define VVBNewButtonNotification @"VVBNewButtonNotification"
//	name of the notification that's posted when something needs to find the button manager
#define VVBManagerFinderNotification @"VVBManagerFinderNotification"
//	name of the notification that's posted when the user needs to show/hide the shortcuts...
#define VVBMShowShortcutsNotification @"VVBMShowShortcutsNotification"
//	macros for *cleanly* implementing locking in sliders
#define BUTTONLOCK1														\
	BOOL			considerLockedButtons = NO;									\
	BOOL			doLockedButtons = NO;										\
																		\
	if (hasLockedButtons || lockedFlag)											\
		considerLockedButtons = YES;											\
	doLockedButtons = [self okayToTriggerLockedButtons];							\
	if (doLockedButtons)	{													\
		if (hasLockedButtons)	{											\
			NSEnumerator		*buttonIt = [lockedButtonArray objectEnumerator];		\
			VVButton			*buttonPtr;									\
			while (buttonPtr = [buttonIt nextObject])	{
				/*	call the method i'm in here...	*/
#define BUTTONLOCK2														\
			}															\
		}																\
		else if (lockedFlag)	{
			/*	call the method i'm in here...	*/
#define BUTTONLOCK3														\
		}																\
		pthread_mutex_unlock(&lockedButtonLock);								\
	}																	\
	if ((considerLockedButtons && doLockedButtons) || (!considerLockedButtons))	{		
		/*	this is where the actual code for doing whatever it is i'm supposed to be doing goes	*/
#define BUTTONLOCK4														\
	}









#define VVBOnFillColor [NSColor colorWithCalibratedRed:0.75 green:0.00 blue:0.02 alpha:1.0]
#define VVBOnStrokeColor [NSColor colorWithCalibratedRed:0.92 green:0.92 blue:0.92 alpha:1.0]
#define VVBOnTextColor [NSColor colorWithCalibratedRed:1.0 green:1.0 blue:1.0 alpha:1.0]
#define VVBTransitionFillColor [NSColor colorWithCalibratedRed:0.5 green:0.5 blue:0.5 alpha:1.0]
#define VVBTransitionStrokeColor [NSColor colorWithCalibratedRed:0.5 green:0.5 blue:0.5 alpha:1.0]
#define VVBOffFillColor [NSColor colorWithCalibratedRed:0.13 green:0.13 blue:0.13 alpha:1.0]
#define VVBOffStrokeColor [NSColor colorWithCalibratedRed:0.09 green:0.09 blue:0.09 alpha:1.0]
#define VVBOffTextColor [NSColor colorWithCalibratedRed:0.45 green:0.45 blue:0.45 alpha:1.0]

#define VVBHLMOnFillColor [NSColor colorWithCalibratedRed:0.75 green:0.00 blue:0.02 alpha:1.0]
#define VVBHLMOnStrokeColor [NSColor colorWithCalibratedRed:0.92 green:0.92 blue:0.92 alpha:1.0]
#define VVBHLMOnTextColor [NSColor colorWithCalibratedRed:1.0 green:1.0 blue:1.0 alpha:1.0]
#define VVBHLMTransitionFillColor [NSColor colorWithCalibratedRed:0.5 green:0.5 blue:0.5 alpha:1.0]
#define VVBHLMTransitionStrokeColor [NSColor colorWithCalibratedRed:0.5 green:0.5 blue:0.5 alpha:1.0]
#define VVBHLMOffFillColor [NSColor colorWithCalibratedRed:0.13 green:0.13 blue:0.13 alpha:1.0]
#define VVBHLMOffStrokeColor [NSColor colorWithCalibratedRed:0.09 green:0.09 blue:0.09 alpha:1.0]
#define VVBHLMOffTextColor [NSColor colorWithCalibratedRed:0.45 green:0.45 blue:0.45 alpha:1.0]










//	the data-source basic categories
#define VVDSHardwareCat @"Hardware"
#define VVDSMIDICat @"MIDI"
#define VVDSKeyCat @"Key"
#define VVDSButtonCat @"Button"
#define VVDSDedMIDICat @"Dedicated MIDI"
#define VVDSOSCCat @"OSC"
#define VVDSDedOSCCat @"Dedicated OSC"

//	name of the notification sent when the list of data sources has changed & needs to be reloaded
#define VVDSSourcesChangedNotification @"VVDSSourcesChangedNotification"
//	name of the notification to post when i need to find the data source controller
#define VVDSControllerFinderNotification @"VVDSControllerFinderNotification"
//	name of the notification that's posted when contextual menus for data sources need to be reloaded
#define VVDSReloadContextualMenusNotification @"VVDSReloadContextualMenusNotification"
//	name of the notification that's posted when the DSC's hardware learn mode changes
#define VVDSHardwareLearnModeChangedNotification @"VVDSHardwareLearnModeChangedNotification"


//	name of the notification that's fired (from a VVOSCOutPort) when it's about to be deleted (but before it's deleted)
#define VVOSCOutPortDeletionNotification @"VVOSCOutPortDeletionNotification"
//	name of the notification that's fired (from the OSCPrefsController or VVOSCManager) when the list of OSC output ports has changed
#define VVOSCOutPortsChangedNotification @"VVOSCOutPortsChangedNotification"









//	midi-related notification defines
//	status messages that go to a specific channel
#define VVMIDINoteOff @"VVMIDINoteOff"			//	+2 data bytes
#define VVMIDINoteOn @"VVMIDINoteOn"			//	+2 data bytes
#define VVMIDIAfterTouch @"VVMIDIAfterTouch"		//	+2 data bytes
#define VVMIDIControlChange @"VVMIDIControlChange"		//	+2 data bytes
#define VVMIDIProgramChange @"VVMIDIProgramChange"		//	+1 data byte
#define VVMIDIChannelPressure @"VVMIDIChannelPressure"	//	+1 data byte
#define VVMIDIPitchWheel @"VVMIDIPitchWheel"		//	+2 data bytes
//	status messages that go anywhere/everywhere
//	0xF0 - 0xF7		system common messages
#define VVMIDIBeginSysexDump @"VVMIDIBeginSysexDump"	//	signals the start of a sysex dump; unknown amount of data to follow
#define VVMIDIMTCQuarterFrame @"VVMIDIMTCQuarterFrame"	//	+1 data byte, rep. time code; 0-127
#define VVMIDISongPosPointer @"VVMIDISongPosPointer"		//	+ 2 data bytes, rep. 14-bit val; this is MIDI beat on which to start song.
#define VVMIDISongSelect @"VVMIDISongSelect"		//	+1 data byte, rep. song number; 0-127
#define VVMIDIUndefinedCommon1 @"VVMIDIUndefinedCommon1"
#define VVMIDIUndefinedCommon2 @"VVMIDIUndefinedCommon2"
#define VVMIDITuneRequest @"VVMIDITuneRequest"		//	no data bytes!
#define VVMIDIEndSysexDump @"VVMIDIEndSysexDump"		//	signals the end of a sysex dump
//	0xF8 - 0xFF		system realtime messages
#define VVMIDIClock	 @"VVMIDIClock"		//	no data bytes! 24 of these per. quarter note/96 per. measure.
#define VVMIDITick @"VVMIDITick"			//	no data bytes! when master clock playing back, sends 1 tick every 10ms.
#define VVMIDIStart @"VVMIDIStart"		//	no data bytes!
#define VVMIDIContinue @"VVMIDIContinue"		//	no data bytes!
#define VVMIDIStop @"VVMIDIStop"			//	no data bytes!
#define VVMIDIUndefinedRealtime1 @"VVMIDIUndefinedRealtime1"
#define VVMIDIActiveSense @"VVMIDIActiveSense"	//	no data bytes! sent every 300 ms. to make sure device is active
#define VVMIDIReset	 @"VVMIDIReset"		//	no data bytes! never received/don't send!


//	this is the string used to identify the notification that occurs when a shortcut was set; it causes all shortcut-outline-views to reload their data
#define VVMIDIReloadAllShortcutViews @"VVMIDIReloadAllShortcutViews"
//	when midi stuff is used to trigger files, the MIDI comes from one thread, and makes QT barf because some stuff still isn't multi-threaded
//	so to trigger files remotely, i implement this notification, and observe it in the layer...
//#define VVTriggerFileManuallyNotification @"VVTriggerFileManuallyNotification"

//	qt barfs if i try to trigger on outside threads; so i have the layer as a registered connection.  here's what it's registered as
//#define VVRegConnLayer @"VVRegConnLayer"

//	when i receive a noteon, it's formatted into a string.  this is the format string.
#define VVMIDINoteOnFmtString @"noteOn [%ld] ch. %ld"
#define VVMIDINoteOffFmtString @"noteOff [%ld] ch. %ld"
#define VVMIDINoteFmtString @"note [%ld] ch. %ld"
#define VVMIDICtrlFmtString @"ctrl [%ld] ch. %ld"
#define VVMIDIPitchWheelFmtString @"ptch.whl. ch. %ld"

//	MIDI devices are hot-swappable; when a new midi devices is added or removed, the list of midi things is updated- this notification fires when they're done uploading and UI elements need to update
#define VVMIDISetupChangedNotification @"VVMIDISetupChangedNotification"
//	objects that need to be polled (for example, for clearing & outputting MIDI queues) post these so the VVMIDIManager will know where to find them (and know when to stop polling them)
#define VVMIDIRegisterForPollNotification @"VVMIDIRegisterForPollNotification"
#define VVMIDIUnregisterForPollNotification @"VVMIDIUnregisterForPollNotification"










//#define WSOBDeselectAllNotification @"WSOBDeselectAllNotification"
//#define WSOBSingleSelectNotification @"WSOBSingleSelectNotification"
//#define WSOBMultipleSelectNotification @"WSOBMultipleSelectNotification"
//#define WSOBMultipleDeselectNotification @"WSOBMultipleDeselectNotification"
//#define WSOBPerformGroupNotification @"WSOBPerformGroupNotification"
//#define WSOBCollapseSetupNotification @"WSOBCollapseSetupNotification"
//#define WSOBCollapseOverlapNotification @"WSOBCollapseOverlapNotification"



//	macros for making a CGRect from an NSRect
#define NSMAKECGRECT(n) CGRectMake(n.origin.x, n.origin.y, n.size.width, n.size.height)
#define NSMAKECGPOINT(n) CGPointMake(n.x, n.y)
#define NSMAKECGSIZE(n) CGSizeMake(n.width, n.height)
//	macros for making an NSRect from a CGRect
#define CGMAKENSRECT(n) NSMakeRect(n.origin.x, n.origin.y, n.size.width, n.size.height)




//	FXObjectPanel vals
#define BARHEIGHT 12
#define VVFXPanelClickNone 0
#define VVFXPanelClickCollapse 1
#define VVFXPanelClickOnOff 2
#define VVFXPanelClickDelete 4
#define VVFXPanelClickResize 8






//	notification that the list of behavior chains have changed, and anything that displays behavior chains needs to reload data
#define VVBehaviorChainNotification @"VVBehaviorChainNotification"






//	when a new plugin is created, it posts a notification so the pluginManager can send it data
#define VVPluginNewPluginNotification @"VVPluginNewPluginNotification"
//	when a plugin is actually added to the plugin array, post this notification
#define VVPluginAddedNotification @"VVPluginAddedNotification"
//	when a plugin is deleted, the plugin manager posts a notification
#define VVPluginRenamedNotification @"VVPluginRenamedNotification"
//	when a plugin is deleted, the plugin manager posts a notification
#define VVPluginDeletedNotification @"VVPluginDeletedNotification"







//	drag-type for layers
#define VVLayerDragType @"VVLayerDragType"
#define VVLayerTabDragPboardName @"VVLayerDragPboardName"
#define VVLayerTabDragType @"VVLayerTabDragType"

//	these are defines for the new media bin / page system
//	when i'm dragging a page.. these can get dropped in places like the MB TOC
#define VVMBPageDragType @"VVMBPageDragType"
//	when the list of pages changes
#define VVMBPageListChangedNotification @"VVMBPageListChangedNotification"
//	when the visible pages for a media bin changes, userDict contains id of the page that changed
#define VVMBVisiblePagesChangedNotification @"VVMBVisiblePagesChangedNotification"

//	name for the pasteboard used to drag files around in the new bin
#define VVFileDragPboardName @"VVFileDragPboardName"


//	these are all defines for the old media bin...
//	when i'm dragging a layer from the media bin's layer list to the media bin's trigger queue, this is the name of the drag type
#define VVMBLayerDragType @"VVMBLayerDragType"
//	when i'm rearranging items in the queue controller's list, this is the drag type.  only for dragging within queue controller lists
#define VVMBQueueItemDragType @"VVMBQueueItemDragType"
//	when i add files to the media bin, all media bins must be re-loaded; this is the name of the notification which does just that.
#define VVMBReloadAllNotification @"VVMBReloadAllNotification"
//	name for the pasteboard used to drag cells from the VVMBGridController class (a subclass of NSView)
#define VVMBPboardName @"VVMBPboardName"





//	when i start loading files
#define VVFileLoaderStartedLoad @"VVFileLoaderStartedLoad"
//	for each file about to be loaded / just finished loading
#define VVFileLoaderLoadingFile @"VVFileLoaderLoadingFile"
//	when i've finished loading files
#define VVFileLoaderFinishedLoad @"VVFileLoaderFinishedLoad"
//	when the warp points for a file change
#define VVFileWarpMarkersChanged @"VVFileWarpMarkersChanged"
//	when the poster frame of a clip changes
#define VVFilePosterImageChangedNotification @"VVFilePosterImageChangedNotification"
//	when a movieProps parameter of a file is adjusted
#define VVFileMoviePropsUpdatedNotification @"VVFileMoviePropsUpdatedNotification"





//	when i load a set file or restore presets, i need to post a notification to tell all the plugins/etc. to temporarily stop receiving notifications- this should speed things up greatly...
#define VVPMRestoreStartNotification @"VVPMRestoreStartNotification"
#define VVPMRestoreEndNotification @"VVPMRestoreEndNotification"
//	some objects need to know what kind of preset's being fired, so they can react appropriately.  these are the different kinds of presets:
#define VVPMEverythingPresetType @"Everything"
#define VVPMPluginsPresetType @"Plugins"
#define VVPMLayersPresetType @"Layers"
#define VVPMLayerFXPresetType @"Layer FX"
//	when i'm restoring the rootFolder from a snapshot, i need to be aware of missing files- this message is posted at the start of a load, so i know to clear the list of missing files....
#define VVPMAboutToLoadNotification @"VVPMAboutToLoadNotification"
//	when i'm restoring the rootFolder from a snapshot, if a file's missing the following notification is posted
#define VVMBMissingFileNotification @"VVMBMissingFileNotification"
//	when i'm changing the order of presets in the preset manager, this is the name of the pasteboard which things are dragged on
#define VVPMPresetDragPboardType @"VVPMPresetDragPboardType"
//	keys for the preset manager's array controller
 #define VVPMNameKey @"VVPMNameKey"
 #define VVPMTypeKey @"VVPMTypeKey"
 #define VVPMIndexKey @"VVPMIndexKey"





//	when i create a layer, a notification is posted with the layer
#define VVLayerCreateNotification @"VVLayerCreateNotification"
//	when i delete a layer, a notification is posted (the notification's object is the layer which is being deleted) so plugins can update just prior to actual layer deletion
#define VVLayerDeleteNotification @"VVLayerDeleteNotification"
//	when i rename a layer, a notification is posted so plugins can update their layer names.  userInfo is a dict with two keys: 'oldName' and 'newName'
#define VVLayerNameChangeNotification @"VVLayerNameChangeNotification"
//	when i change a layer's source, this notification is posted.  the object passed is the layer whose source has changed; there is no other info, as the change is posted *after* the source has changed.
#define VVLayerSourceChangeNotification @"VVLayerSourceChangeNotification"
//	when a layer's comp. mode is changed, this notification gets posted
#define VVLayerCompModeChangeNotification @"VVLayerCompModeChangeNotification"
//	notification that the list of layer chains has changed (layer added/removed), and anything that displays layers needs to reload data
#define VVLayersChangedNotification @"VVLayersChangedNotification"
//	notification that the list of individual layer fx chain presets has been updated
#define VVLayerFXPresetUpdateNotification @"VVLayerFXPresetUpdateNotification"
//	the layer chain manager needs to be found periodically, so it calls 'setLayerChainManager:self' to anything that posts this notification
#define VVLayerChainManagerFinderNotification @"VVLayerChainManagerFinderNotification"
//	notification that the frontmost media bin changed, and the media inspector should update it's contents accordingly
#define VVMBFrontmostBinChangedNotification @"VVMBFrontmostBinChangedNotification"
//	notification that the selected items in a media bin changed.  every media bin spits this out, MediaInspector selectively observes these notifications
#define VVMBSelectionInBinChangedNotification @"VVMBSelectionInBinChangedNotification"
//	notification that the bounds of a layer have changed
#define VVLayerBoundsChangedNotification @"VVLayerBoundsChangedNotification"
//	notification that a layer has triggered a new file
#define VVLayerTriggerFileNotification @"VVLayerTriggerFileNotification"
//	notification that a MovieSource's QTMovie has looped or ended
#define VVMovieSourceQTMovieDidEnd @"VVMovieSourceQTMovieDidEnd"





#define VVCompositorFinderNotification @"VVCompositorFinderNotification"
#define VVGWorldFinderNotification @"VVGWorldFinderNotification"





//	the notification that's posted when anything needs to find the AppWindowMenuController instance
#define VVWMCFindWinMCNotification @"VVWMCFindWinMCNotification"
//	the notification that's posted when the user locks or unlocks the interface
#define VVWMCLockChangedNotification @"VVWMCLockChangedNotification"
//	the notification that's fired to add a palette window to the AppWindowMenuController
#define VVWMCAddPaletteWindowNotification @"VVWMCAddPaletteWindowNotification"
//	the notification that's fired to add a plugin window to the AppWindowMenuController
#define VVWMCAddPluginWindowNotification @"VVWMCAddPluginWindowNotification"
//	the notification that's fired to add a layer window to the AppWindowMenuController
#define VVWMCAddLayerWindowNotification @"VVWMCAddLayerWindowNotification"
//	the notification that's fired to remove a plugin *or* preset window (really, any window) from the AppWindowMenuController
#define VVWMCRemoveWindowNotification @"VVWMCRemoveWindowNotification"
//	the notification that the list of windows must be reloaded- typically used when a plugin window is renamed, and the list has to be refreshed
#define VVWMCReloadMenuNotification @"VVWMCReloadMenuNotification"
//	if i fire this notification, ever VVPaletteWindow will move to it's 'default' location (used primarily when creating new projects)
#define VVWMCPalettesToDefLocNotification @"VVWMCPalettesToDefLocNotification"
//	if i fire this notification, all windows will redraw
#define VVWMCRedrawWindowsNotification @"VVWMCRedrawWindowsNotification"






//	this is the notification that's fired when i need to force table views to redraw (like when i'm changing their colors)
#define VVRedrawTablesNotification @"VVRedrawTablesNotification"
//	this is the notification that's fired when i need to force text labels to redraw (like when i'm changing their colors)
#define VVRedrawLabelsNotification @"VVRedrawLabelsNotification"
//	this is the notification that's fired when i need to force the level views to redraw (like when i'm changing their colors)
#define VVRedrawLevelsNotification @"VVRedrawLevelsNotification"
//	this is the notification that's fired when i need to force the pop-up views to redraw (like when i'm changing their colors)
#define VVRedrawPopUpsNotification @"VVRedrawPopUpsNotification"
//	this is the notification that's fired when i need to force the bezier views to redraw (like when i'm changing their colors)
#define VVRedrawBeziersNotification @"VVRedrawBeziersNotification"
//	this is the notification that's fired when i need to force the plugins to redraw
#define VVRedrawPluginsNotification @"VVRedrawPluginsNotification"
//	this is the notification that's fired when i need to force the fx to redraw (like when i'm changing their colors)
#define VVRedrawFXNotification @"VVRedrawFXNotification"





//	notification that's posted when a new tap is created
#define VVTapNewTapNotification @"VVTapNewTapNotification"
//	notification that's posted when a tap is deleted
#define VVTapDeleteTapNotification @"VVTapDeleteTapNotification"
//	notification that's posted when a tap is renamed
#define VVTapRenameTapNotification @"VVTapRenameTapNotification"
//	notification that sTaps need to reload their list of taps...
#define VVTapReloadSTapListNotification @"VVTapReloadSTapListNotification"





//	notification that's posted when the sequence grabber is prepping to begin recording
#define VVSGStartRecordingNotification @"VVSGStartRecordingNotification"
//	notification that's posted when the sequence grabber is done recording
#define VVSGStopRecordingNotification @"VVSGStopRecordingNotification"
//	notification that's posted when the sequence grabber is done exporting tracks to video files- userInfo dict contains description of the exported files
#define VVSGExportDoneNotification @"VVSGExportDoneNotification"





//	notification for finding the file loader
#define VVFindFileLoaderNotification @"VVFindFileLoaderNotification"
//	notification that's posted when folders are renamed
#define VVFolderRenamedNotification @"VVFolderRenamedNotification"
//	notification that's posted when folders are added to a folder (this happens when it is first added and when folders are moved)
#define VVFolderAddedNotification @"VVFolderAddedNotification"
//	when i delete files (or folders!) from a media bin, all other media bins need to ensure that they're not attempting to display the deleted file/folder
#define VVMBFileFolderDeletedNotification @"VVMBFileFolderDeletedNotification"
//	when files are finished being deleted, this notification gets posted
#define VVPCFinishedDeletingFilesNotification @"VVPCFinishedDeletingFilesNotification"
//	notification that's posted when the folder list menu is updated
#define VVFolderListMenuUpdatedNotification @"VVFolderListMenuUpdatedNotification" 



//	notification posted when an object needs to check a stat- the userInfo dict determines which stat to check, and how to return it
#define VVStatCheckNotification @"VVStatCheckNotification"



//	notification that the size of the canvas (display area) has changed
#define VVCanvasSizeChangedNotification @"CanvasSizeChangedNotification"









//	drag-type for media files (VVMediaBin = VVMB)
#define VVMBDragType @"VVMBDragType"
#define VVMBTabDragType @"VVMBTabDragType"





//	notification that the list of audio inputs and outputs has changed
#define VVAudioHardwareChangedNotification @"VVAudioHardwareChangedNotification"








//	name of the notification that's posted when something needs to find the master clock
#define VVMCFinderNotification @"VVMCFinderNotification"
//	when the master clock is updated, some things need to update their particulars (such as how many beats per measure, subdivisions, etc.)
#define VVMCUpdateParticularsNotification @"VVMCUpdateParticularsNotification"
//	when the master clock is BPM is changed
#define VVMCMeasureDurationChangedNotification @"VVMCMeasureDurationChangedNotification"





//	when you click on a preview window, it sends off a notification with the color of the pixel that was clicked on
#define VVPrevWinClickColorNotification @"VVPrevWinClickColorNotification"





//	when a wave is saved to disk, I need to tell existing wave menus to update
#define VVWaveformMenuNeedsUpdateNotification @"VVWaveformMenuNeedsUpdateNotification"






//	some fx (CIFilters, that is) need to find the FXLoader that made them.  specifically, this was made so some filers can check their loaders to see what size their buffers are supposed to be when it gets passed an oddly-sized image.
#define VVCIFXLoaderFinderNotification @"VVCIFXLoaderFinderNotification"




#endif