


@protocol LayerProtocol

- (int) depth;	//	returns the depth
- (BOOL) useSourceRes;
- (BOOL) groupFlag;
- (NSMutableArray *) layerArray;
- (void) setLayerName:(NSString *) newName;
- (NSString *) layerName;
- (id) parentLayer;
- (NSSize) layerSize;
- (void) setLayerSize:(NSSize)n;
- (NSRect) activeRect;
- (void) setActiveRect:(NSRect)newRect;
- (id) compFilter;
- (void) useCompModeNamed:(NSString *)realCompName;
- (NSString *) compName;
- (BOOL) containsThisLayer:(id)containsMe;
- (id) compositor;
- (void) fxChainModified;
- (int) orderedLayerIndex;
- (id) alphaSlider;
- (NSString *) currentSourceAsString;
- (id) currentSource;
- (id) alphaButton;

@end




@protocol LayerWindowProtocol

- (id) currentlyDisplayedLayer;
- (id) sourceCompUIController;

@end


