//
//  VVBMContextualMenuController.h
//  VDMX
//
//  Created by bagheera on 11/15/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import "VVButtonManager.h"
@class VVButtonManager;
//#import "DataSourceController.h"
@class DataSourceController;
//#import "TheApplication.h"


@interface VVBMContextualMenuController : NSObject {
	IBOutlet NSMenu				*buttonContextualMenu;
	IBOutlet NSMenuItem				*synchMenuItem;	//	turns synching on/off
	IBOutlet NSMenuItem				*triggerModeStraightSyncItem;
	IBOutlet NSMenuItem				*triggerModeEdgeTriggerItem;
	IBOutlet NSMenuItem				*triggerRiseMenuItem;	//	turns trigger on rise on/off
	IBOutlet NSMenuItem				*triggerFallMenuItem;	//	turn trigger on fall on/off
	IBOutlet NSMenuItem				*showSyncToggleItem;
	IBOutlet NSMenuItem				*dataSourcesLabelItem;	//	the text 'Use This Data Source:' above the list- ONLY A LABEL
	//NSMutableArray				*dataSourceMenuItems;	//	array of data source menu items that can be deleted
	IBOutlet VVButtonManager			*buttonManager;
	IBOutlet DataSourceController	*dataSourceController;
	//ATSFontContainerRef			*loadedFontContainerRef;
}

//- (void) loadFontFromResources;

- (IBAction) buttonContextualMenuUsed:(id)sender;
- (IBAction) buttonCMDataSourceChosen:(id)sender;
- (void) reloadDSContextualMenu;	//	actually reloads the data sources in the menu
- (void) prepRawMenu:(NSMenu *)m;	//	sets the target/action for all the menu items and enables/disables them appropriately

- (void) deselectAllDataSources;	//	un-checks all the data sources
- (void) deselectAllItemsInMenu:(NSMenu *)m;
- (void) selectDataSourceNamed:(NSString *)n;
- (BOOL) selectItemForSourceString:(NSString *)s inMenu:(NSMenu *)m;

- (NSMenu *) buttonContextualMenu;
- (NSMenuItem *) synchMenuItem;
- (NSMenuItem *) triggerRiseMenuItem;
- (NSMenuItem *) triggerFallMenuItem;
- (NSMenuItem *) dataSourcesLabelItem;
- (NSMenuItem *) triggerModeStraightSyncItem;
- (NSMenuItem *) triggerModeEdgeTriggerItem;
- (NSMenuItem *) showSyncToggleItem;

@end
