//
//  VVBMInterfaceManager.h
//  VDMX
//
//  Created by bagheera on 7/26/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVButtonManager.h"
@class VVButtonManager;
#import "VVBMDSListController.h"
@class VVBMDSListController;
//#import "SimpleLevelView.h"
//@class SimpleLevelView;
//#import "VVNSTabView.h"
#import "RandomUIObjects.h"




@interface VVBMInterfaceManager : NSObject {
	IBOutlet VVButton			*fallToggle;
	IBOutlet VVButton			*midiDetectButton;
	IBOutlet VVButton			*oscDetectButton;
	IBOutlet VVButton			*riseToggle;
	IBOutlet VVButton			*syncToggle;
	IBOutlet VVButton			*keyDetectButton;
	IBOutlet VVButton			*hardwareLearnButton;
	IBOutlet VVButton			*triggerModeButton;
	IBOutlet VVButton			*showSyncToggleButton;
	
	IBOutlet VVButtonManager		*buttonManager;
	IBOutlet id					sliderManager;
	IBOutlet NSSlider			*threshSlider;
	//IBOutlet NSOutlineView		*sourceView;
	IBOutlet VVBMDSListController	*sourceViewController;
	IBOutlet VVButton			*showShortcutButton;
	
	IBOutlet SimpleLevelView		*levelView;
	IBOutlet id					dataSourceController;
	
	IBOutlet VVNSTabView		*inspectorTabView;
}

//	called by VVButtonManager when i need to update my contents to reflect the currently selected button
- (void) updateWithLockedStatus:(BOOL)lockFlag;
- (void) updateValueRelatedOnlyWithValue:(float)f;

//	actual interface-interaction methods for the .nib
- (IBAction) syncToggleUsed:(id)sender;
- (IBAction) valThreshUsed:(id)sender;
- (IBAction) riseToggleUsed:(id)sender;
- (IBAction) fallToggleUsed:(id)sender;
- (IBAction) midiDetectClicked:(id)sender;
- (IBAction) oscDetectUsed:(id)sender;
//- (IBAction) hardwareLearnUsed:(id)sender;
- (IBAction) keyDetectClicked:(id)sender;
- (IBAction) showShortcutsClicked:(id)sender;
- (IBAction) triggerModeButtonUsed:(id)sender;
- (IBAction) showSyncToggleButtonUsed:(id)sender;

- (VVButton *) showShortcutButton;
- (VVButton *) hardwareLearnButton;
- (VVButton *) syncToggle;
- (VVButton *) riseToggle;
- (VVButton *) fallToggle;
- (VVButton *) triggerModeButton;
- (VVButton *) keyDetectButton;
- (VVButton *) midiDetectButton;
- (VVButton *) oscDetectButton;


@end
