//
//  VVMIDIEndpoint.h
//  VDMX
//
//  Created by bagheera on 4/22/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/CoreMIDI.h>


@interface VVMIDIEndpoint : NSObject {
	MIDIEndpointRef			endpoint;
	NSString					*endpointName;
	BOOL						deleting;
}

+ (id) createWithEndpoint:(MIDIEndpointRef)n;
- (id) initWithEndpoint:(MIDIEndpointRef)n;
- (void) prepareToBeDeleted;
- (MIDIEndpointRef) endpoint;
- (void) setEndpoint:(MIDIEndpointRef)n;
- (NSString *) endpointName;
- (void) setEndpointName:(NSString *)n;
- (BOOL) deleting;

@end


static CFStringRef ConnectedEndpointName(MIDIEndpointRef endpoint);
static CFStringRef EndpointName(MIDIEndpointRef endpoint, bool isExternal);