//
//  VVNSPopUpButton.h
//  VDMX
//
//  Created by bagheera on 11/3/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
//#import "TheApplication.h"


@interface VVNSPopUpButton : NSPopUpButton {
	NSSize			lastRenderedSize;
	NSBezierPath		*framePath;	//	stroke around the frame, or fill for the button...
	NSBezierPath		*frameArrowBGPath;	//	the half-rounded-rect that goes around the arrows on the right
	NSBezierPath		*arrowPath;	//	the arrow on the right-hand side
	NSDictionary		*fontAttribs;
	//NSColor			*fillColor;	//	color used to fill the button
	//NSColor			*strokeColor;	//	color used to stroke the button
	//NSColor			*textColor;
}

//- (void) setFontAttribs:(NSDictionary *)newAttribs;
- (NSBezierPath *) roundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
- (NSBezierPath *) halfRoundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
//- (void) setFillColor:(NSColor *)c;
//- (void) setStrokeColor:(NSColor *)c;
- (void) forceRedrawNotification:(NSNotification *)n;
//- (void) testPopUpButtonFinder:(NSNotification *)n;


@end
