//
//  VVOSCBundle.h
//  OSCtest
//
//  Created by bagheera on 10/12/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface VVOSCBundle : NSObject {
	NSMutableArray		*elementArray;
	int					rawBufferLength;
}

+ (id) createFromRawBuffer:(void *)b ofMaxLength:(int)l;
+ (id) createWithElementArray:(NSArray *)a;
- (id) initFromRawBuffer:(void *)b ofMaxLength:(int)l;
- (id) initWithElementArray:(NSArray *)a;
//- (void) addElementsToArray:(NSMutableArray *)a;
- (void) addToDict:(NSMutableDictionary *)d;

- (char *) rawBuffer;
- (int) rawBufferLength;

@end
