//
//  VVOSCManager.h
//  VDMX
//
//  Created by bagheera on 10/14/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVOSCInPort.h"
#import "VVOSCOutPort.h"
#import <pthread.h>
#import "DataSourceController.h"
//#import <VVEssentials/VVEssentials.h>




@interface VVOSCManager : NSObject {
	id					appController;
	DataSourceController	*dataSourceController;
	pthread_rwlock_t		inPortLock;
	NSMutableArray		*inPortArray;
	pthread_rwlock_t		outPortLock;
	NSMutableArray		*outPortArray;
	NSMutableDictionary		*scratchDict;
	
	NSMutableDictionary		*dedicatedSourcesDict;
}

- (id) initWithAppController:(id)a;

- (void) createNewInPort;
- (void) createNewOutPort;
- (VVOSCOutPort *) getOutPortNamed:(NSString *)n;
- (void) savePortsToDefaults;
- (void) loadPortsFromDefaults;

//- (void) DSCProc;
- (void) saveDedicatedToDefaults;
- (void) loadDedicatedFromDefaults;


- (NSMutableArray *) inPortArray;
- (NSMutableArray *) outPortArray;
- (NSMutableDictionary *) dedicatedSourcesDict;

@end
