//
//  VVOSCMessage.h
//  OSCtest
//
//  Created by bagheera on 10/12/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface VVOSCMessage : NSObject {
	NSString			*address;
	NSMutableArray	*arguments;
	int				rawBufferLength;	//	the length of this message, as output to a raw buffer
}

- (NSString *) description;
+ (id) createFromRawBuffer:(void *)b ofMaxLength:(int)l;
+ (id) createWithAddress:(NSString *)a andFloatArg:(float)f;
- (id) initFromRawBuffer:(void *)b ofMaxLength:(int)l;
- (id) initWithAddress:(NSString *)a andFloatArg:(float)f;

- (char *) rawBuffer;
- (void) fillThisBuffer:(char *)b;
- (int) rawBufferLength;

//- (void) dumpToScratchDict:(NSMutableDictionary *)d;
- (void) addToDict:(NSMutableDictionary *)d;

@end
