//
//  VVSMBehaviorListController.h
//  VDMX
//
//  Created by bagheera on 5/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVSliderManager.h"
@class VVSliderManager;


@interface VVSMBehaviorListController : NSObject {
	//IBOutlet NSOutlineView		*outlineView;
	//IBOutlet NSTableColumn		*behaviorTableColumn;
	IBOutlet VVNSPopUpButton		*behaviorPopUpButton;
	IBOutlet VVSliderManager		*sliderManager;
	BOOL						acknowledgeSelectionChange;	//	if YES, then changes to the list's selection affect the currently selected slider(s)
}

//	notification is posted when the list of available behaviors has changed
- (void) behaviorsChangedNotification:(NSNotification *)note;

//	actions that correspond to this instance as a data source (supplying data) for the NSOutlineView
//	returns the child item and the specified index.  if nil, return appropriate child of the root object.
//- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item;
//	method should return YES if item can be expanded to display children
//- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item;
//	returns the number of child items encompassed by item.  if item is nil, return number of children of root object.
//- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item;
//	return the data object associated with the specified item, located in the specified tablecolumn of the view
//- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;

//	actions that correspond to this instance as a delegate (dealing with user interaction with) the NSOutlineView
//- (void) outlineViewSelectionIsChanging:(NSNotification *)notification;
//- (void) outlineViewSelectionDidChange:(NSNotification *)notification;

- (void) selectItemForString:(NSString *)a;
- (IBAction) behaviorPopUpButtonUsed:(id)sender;

- (void) reloadView;

//	periodically, i may need to ignore selection-changes from the outlineView
- (void) setAcknowledgeSelectionChange:(BOOL)newValue;
- (BOOL) acknowledgeSelectionChange;

//	this method is called when something was double-clicked on the outline view
//- (void) doubleClicked;

@end
