//
//  VVSTap.h
//  VVSliders
//
//  Created by bagheera on 4/13/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
@class VVRTapStub;




@interface VVSTap : NSObject {
	id				tapManager;
	NSString			*tapName;
	id				layer;
	VVRTapStub		*stub;
}

- (id) initWithLayer:(id)newLayer;

//- (void) deleteMe;
- (void) prepareToBeDeleted;

- (void) setTapManager:(id)newManager;

- (int) orderedIndexRelativeTo:(VVSTap *) otherTap;

- (void) setCIImage:(CIImage *)newImage;

- (void) updateAccumulatorSize;

- (void) changeTapNameTo:(NSString *) newName;

//	when a layer's bounds (size/pos) change, the accumulator has to be cleared.  the layer calls this method when they change.
- (void) boundsChanged;
- (NSSize) imageSize;

- (NSString *) tapName;
- (id) layer;
- (VVRTapStub *) stub;
- (void) setStub:(VVRTapStub *) newStub;


@end
