//
//  VVSafeString.h
//  VDMX
//
//  Created by bagheera on 12/6/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <pthread.h>


@interface VVSafeString : NSObject {
	pthread_mutex_t		lock;
	NSString				*theString;
	NSMutableDictionary		*fontAttribs;
}

- (id) initWithString:(NSString *)n;
- (void) drawAtPoint:(NSPoint)p;
- (void) drawAtPoint:(NSPoint)p withAttributes:(NSDictionary *)d;
- (void) setFont:(NSFont *)f;
- (void) setForegroundColor:(NSColor *)c;
- (void) setAttributes:(NSDictionary *)d;
- (void) setCustomString:(NSString *)s;
- (void) setString:(NSString *)s;

- (NSSize) textSize;


@end
