//
//  VVSingleSplineView.h
//  VDMX
//
//  Created by David Lublin on 12/29/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import "VVQuadraticSpline.h"
//@class VVQuadraticSpline;
#import "VVSingleSpline.h"
//@class VVSingleSpline;
#import "VVSplineToolsView.h"
//@class VVSplineToolsView;
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
//#import "TheApplication.h"



@interface VVSingleSplineView : NSView <VVSnapshotProtocol> {
	IBOutlet VVSplineToolsView	*splineTools;

	VVSingleSpline				*theSpline;
	
	float						snapSensitivity;

	NSColor					*bgColor;
	NSColor					*curveFillColor;
	NSColor					*curveLineColor;
	NSColor					*controlPtLineDefaultColor;
	NSColor					*controlPtLineSelectedColor;
	NSColor					*handleRectDefaultColor;
	NSColor					*handleRectSelectedColor;
	NSColor					*snapLinesColor;
	NSColor					*startLineColor;
	
	NSPoint					lastPoint;
	
	NSTrackingRectTag			viewTrackingRectTag;
	BOOL						deleted;		//	set to YES on prepareToBeDeleted
}

- (void) prepareToBeDeleted;
- (float)evaluateAt:(float)x;
//- (void)putUISnapshotInDict:(NSMutableDictionary *)fxDict;
//- (NSMutableDictionary *) createSnapshot;
//- (void)loadUISnapshotFromDict:(NSDictionary *)fxDict;
- (IBAction)saveToDisk:(id)sender;
- (IBAction)loadFromDisk:(id)sender;
- (VVSingleSpline *)theSpline;
- (void) setSplineTools:(VVSplineToolsView *)toolsPtr;

- (void) forceRedrawNotification:(NSNotification *)note;

- (void) prepareTrackingRects;
- (void) clearTrackingRects;
- (void)resetCursorRects;

@end
