//
//  BehaviorChainWindow.h
//  VDMX
//
//  Created by bagheera on 5/16/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "BehaviorChainManager.h"
@class BehaviorChainManager;
@class BehaviorFXChain;
//#import "VVRBSplitView.h"
#import "GlobalKeys.h"
#import "RandomUIObjects.h"




@interface BehaviorChainWindow : NSWindowController {
	IBOutlet id				myJunkView;		//	to make scroll view, have to subclass something.  this is the something.  DELETED IN INIT
	IBOutlet id				myScrollView;		//	just what it sounds like.
	IBOutlet id				creationListController;	//	pts to 'FXWinCreationList' class (fx to be created)
	IBOutlet id				chainListController;	//	pts to 'FXWinChainListController' class
	IBOutlet NSTableView	*chainArrayTableView;	//	pts to NSTableView that tracks all the chains in this window
	//IBOutlet NSTableView	*creationListTableView;
	BehaviorChainManager	*behaviorChainManager;	//	ptr to my chain manager
	NSMutableArray		*chainArray;
	BehaviorFXChain		*visibleChain;
	
	NSString				*windowTitle;
	NSNumber				*paletteStackOrder;
}

- (id) initWithParentManager:(BehaviorChainManager *)myManager;
//- (void) loadSavedBehaviorChains;

//- (void) andOnTheFourteenthDayThereWereBehaviorChains	;

- (void) addChainToMyList:(BehaviorFXChain *)newChain;
- (void) removeChainFromMyList:(BehaviorFXChain *)removeMe;
- (void) displayFX:(BehaviorFXChain *)showMe;
- (void) createEffectInVisibleChain:(NSString *)newFXName;
- (void) windowDidResize:(NSNotification *)notification;
- (void) windowDidMove:(NSNotification *)aNotification;
- (void) didAdjustSubviews:(RBSplitView *)sender;

//	key-value;
- (NSMutableArray *) chainArray;
- (BehaviorChainManager *) behaviorChainManager;
- (id) myScrollView;
- (NSString *) windowTitle;
- (void) setWindowTitle:(NSString *)newTitle;
- (NSTableView *) chainArrayTableView;
- (BehaviorFXChain *) visibleChain;

- (NSNumber *) paletteStackOrder;
- (void) setPaletteStackOrder:(NSNumber *)n;

@end
