//
//  DSFloatFreqNonRepeat.h
//  VDMX
//
//  Created by bagheera on 5/7/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DSFloatFrequent.h"
#import "GlobalKeys.h"



/*
		this class exists so frequent data sources (data sources whose values are set every thread proc)
		will avoid spitting out "repeat" values.  their value will still be set- and called- on the threadProc,
		but the values will be non-repetitive.
*/



@interface DSFloatFreqNonRepeat : DSFloatFrequent {

}

+ (id) createWithName:(NSString *)n setByTarget:(id)t withAction:(SEL)a;
+ (id) createWithName:(NSString *)n ofType:(int)type setByTarget:(id)target withAction:(SEL)a;
+ (id) createWithName:(NSString *)n ofType:(int)t;
+ (id) createWithName:(NSString *)n;
- (id) initWithName:(NSString *)n ofType:(int)t;

@end
