//
//  DSPointHolder.h
//  VDMX
//
//  Created by bagheera on 1/19/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DSCGlobals.h"
#import "DataSourceHolder.h"
#import "DSFloatFrequent.h"




@protocol DSPointHolderDelegateProtocol
- (float) x;
- (float) y;
@end




@interface DSPointHolder : DataSourceHolder {
	id				delegate;
	
	DSFloatFrequent	*x;
	DSFloatFrequent	*y;
	
	float				xVal;
	float				yVal;
}

+ (id) createWithName:(NSString *)n;
- (id) initWithName:(NSString *)n;

- (void) prepareToBeDeleted;

- (void) setParentSource:(DataSource *)np fromDSC:(id)dsc;

- (void) setDataSourceVal:(DSFloatFrequent *)ds;

- (void) setDelegate:(id)n;

@end
