//
//  DataSourceCall.h
//  NewDSCTest
//
//  Created by bagheera on 8/4/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DataSourceProtocol.h"


@interface DataSourceCall : NSObject {
	id			target;
	SEL			action;
	id			dataSource;
}

+ (id) createWithTarget:(id)t action:(SEL)a;

- (id) initWithTarget:(id)t action:(SEL)a;

- (void) bang;
- (void) dataSourceNameChanged:(id)ds;
- (void) dataSourcePrepareToBeDeleted;

- (id) target;
- (void) setTarget:(id)n;
- (SEL) action;
- (void) setAction:(SEL)n;
- (id) dataSource;
- (void) setDataSource:(id)n;


@end
