#import "VVMIDIMsg.h"



@protocol MasterClockProtocol

- (long) beatsPerMeasure;
- (void) midiClockReceived:(VVMIDIMsg *) msg fromMIDISource:(id) source;
- (float) measurePosition;
- (float) measureDuration;
- (long) quantizedSubdivisions;

@end






@protocol MasterClockFinderProtocol

- (void) setMasterClock:(id)n;

@end





