//
//  TheApplication.h
//  VDMX
//
//  Created by bagheera on 10/2/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import "NSMutDictAdditions.h"
//#import "GlobalKeys.h"
#import <VVEssentials/VVEssentials.h>



@interface TheApplication : NSApplication {
	ATSFontContainerRef				*loadedFontContainerRef;
	NSMutableDictionary					*winColorDict;
	NSMutableDictionary					*tableColorDict;
	NSMutableDictionary					*labelColorDict;
	NSMutableDictionary					*levelViewColorDict;
	NSMutableDictionary					*popUpColorDict;
	NSMutableDictionary					*bezierColorDict;
	NSMutableDictionary					*fxColorDict;
	NSMutableDictionary					*pluginColorDict;
	NSMutableDictionary					*buttonColorDict;
	NSMutableDictionary					*sliderColorDict;
}

+ (NSString *) pathToFolderNamed:(NSString *)f;

- (BOOL) acceptsFirstResponder;
- (BOOL) becomeFirstResponder;
- (void) loadFonts;
- (NSMutableDictionary *) winColorDict;
- (void) setWinColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) tableColorDict;
- (void) setTableColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) labelColorDict;
- (void) setLabelColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) levelViewColorDict;
- (void) setLevelViewColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) popUpColorDict;
- (void) setPopUpColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) bezierColorDict;
- (void) setBezierColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) fxColorDict;
- (void) setFxColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) pluginColorDict;
- (void) setPluginColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) buttonColorDict;
- (void) setButtonColorDict:(NSMutableDictionary *)n;
- (NSMutableDictionary *) sliderColorDict;
- (void) setSliderColorDict:(NSMutableDictionary *)n;


@end
