//
//  VVBMDSListController.h
//  VDMX
//
//  Created by bagheera on 7/26/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVButtonManager.h"
@class VVButtonManager;
#import "DataSourceController.h"
@class DataSourceController;
//#import "VVNSPopUpButton.h"
//#import "VVWindow.h"
//#import "FirstResponderTextField.h"
#import "RandomUIObjects.h"



@interface VVBMDSListController : NSObject {
	//IBOutlet NSTableColumn		*dataSourceTableColumn;
	//IBOutlet NSOutlineView		*outlineView;
	IBOutlet VVNSPopUpButton			*sourcePopUpButton;
	IBOutlet FirstResponderTextField	*dataSourceNameTextField;
	IBOutlet VVButtonManager			*buttonManager;
	IBOutlet DataSourceController		*dataSourceController;
	BOOL							acknowledgeSelectionChange;	//	if YES, then changes to the list's selection affect the currently selected slider(s)
}

//- (id) outlineView:(NSOutlineView *)view child:(int)index ofItem:(id)item;
//- (BOOL) outlineView:(NSOutlineView *)view isItemExpandable:(id)item;
//- (int) outlineView:(NSOutlineView *)view numberOfChildrenOfItem:(id)item;
//- (id) outlineView:(NSOutlineView *)view objectValueForTableColumn:(NSTableColumn *)column byItem:(id)item;

//- (void) outlineViewSelectionIsChanging:(NSNotification *)note;
//- (void) outlineViewSelectionDidChange:(NSNotification *)note;

- (void) selectItemForSourceArray:(NSArray *)a;
- (void) deselectAllItemsInMenu:(NSMenu *)m;
- (BOOL) selectItemForSourceString:(NSString *)s inMenu:(NSMenu *)m;
- (IBAction) sourcePopUpButtonUsed:(id)sender;
- (IBAction) dataSourceTextFieldUsed:(id)sender;

- (void) reloadView;
- (void) prepRawMenu:(NSMenu *)m;

- (BOOL) acknowledgeSelectionChange;
- (void) setAcknowledgeSelectionChange:(BOOL)newValue;

//- (void) sourcesChangedNotification:(NSNotification *)note;
- (void) reloadDSContextualMenu;


@end
