//
//  VVBMSMCoordinator.h
//  VDMX
//
//  Created by bagheera on 10/22/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVSliderManager.h"
//@class VVSliderManager;
#import "VVButtonManager.h"
//@class VVButtonManager;
//#import "VVWindow.h"
#import "GlobalKeys.h"
#import "RandomUIObjects.h"
#import "DataSourceController.h"




@interface VVBMSMCoordinator : NSWindowController {
	//IBOutlet id					window;
	IBOutlet NSTabView			*tabView;
	IBOutlet NSTabViewItem		*sliderTab;
	IBOutlet NSTabViewItem		*buttonTab;
	IBOutlet NSTabViewItem		*noneTab;
	IBOutlet VVSliderManager		*sliderManager;
	IBOutlet VVButtonManager		*buttonManager;
	IBOutlet DataSourceController	*dataSourceController;
	NSNumber					*paletteStackOrder;
}

- (void) selectSlider;
- (void) selectButton;
- (void) selectNothing;
//- (id) window;

//	when the window is expanded, i have to re-list the items in the pop-up menus containing data sources
- (void) VVWindowContentViewCollapsedStateChanged:(id)winView;

- (IBAction) hardwareLearnUsed:(id)sender;

- (NSNumber *) paletteStackOrder;
- (void) setPaletteStackOrder:(NSNumber *)n;

@end
