//
//  VVFallThruPopUpButtonCell.h
//  VVSliders
//
//  Created by bagheera on 3/20/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import "TheApplication.h"
//#import <VVEssentials/VVEssentials.h>




@interface VVFallThruPopUpButtonCell : NSPopUpButtonCell {
	NSRect			lastRenderedRect;
	NSBezierPath		*framePath;	//	stroke around the frame, or fill for the button...
	NSBezierPath		*frameArrowBGPath;	//	the half-rounded-rect that goes around the arrows on the right
	NSBezierPath		*arrowPath;	//	the arrow on the right-hand side
	NSDictionary		*fontAttribs;
}

//	this method over-rides the superclasses default behavior of the first click in a non-key window bringing the window to front
- (BOOL) acceptsFirstMouse:(NSEvent *)theEvent;
- (int) indexOfItemWithToolTip:(NSString *)s;
//	drawing stuff
- (NSBezierPath *) roundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
- (NSBezierPath *) halfRoundRectPathInRect:(NSRect)rectFrame withRadius:(float)radius;
//- (void) setFillColor:(NSColor *)c;
//- (void) setStrokeColor:(NSColor *)c;
- (void) forceRedrawNotification:(NSNotification *)n;
@end
