//
//  VVMIDIOutput.h
//  VDMX
//
//  Created by bagheera on 4/20/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/CoreMIDI.h>
#import "VVMIDIEndpoint.h"



@interface VVMIDIOutput : NSObject {
	VVMIDIEndpoint			*sourceEndpoint;
	id					appController;
	MIDIClientRef			client;
	MIDIPortRef			outPort;
	NSMutableArray		*outputDevices;
	id					midiManager;
}

- (id) initWithAppController:(id)a;

- (void) loadOutputDevices;
- (VVMIDIEndpoint *) findEndpointNamed:(NSString *)n;

//- (void) bang;

- (id) midiManager;
- (void) setMidiManager:(id)n;
- (NSMutableArray *) outputDevices;
- (MIDIPortRef) outPort;
- (VVMIDIEndpoint *) sourceEndpoint;


@end




