//
//  VVPlugin.h
//  VDMX
//
//  Created by bagheera on 5/17/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
#import "VVWindow.h"


@interface VVPlugin : NSWindowController <VVSnapshotProtocol> {
	NSString			*name;	//	the name of the plugin; same as the class name
	id				appController;
	id				dataSourceController;
	NSString			*windowTitle;	//	used to store the title between init: (when it gets the title) and awakeFromNib: (when it sets it)
	long				uniqueID;
	BOOL				deleted;
}

- (id) initWithName:(NSString *)newName andWindowTitle:(NSString *)newTitle andUniqueID:(long)u;
- (void) prepareToBeDeleted;
- (id) appController;
- (void) setAppController:(id)newValue;
- (void) setPluginName:(NSString *)newName;
- (NSString *) windowTitle;
- (long) uniqueID;
- (NSComparisonResult) sortByPluginName:(VVPlugin *)comp;

//- (NSMutableDictionary *) createSnapshot;
//- (void) applySnapshot:(NSMutableDictionary *)snap;

- (void) selectedInWindowMenu;

- (NSString *)name;
- (id) dataSourceController;
- (void) setDataSourceController:(id)n;
- (VVWindow *) window;
- (BOOL) deleted;

@end
