//
//  VVRTap.h
//  VVSliders
//
//  Created by bagheera on 4/13/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
@class VVRTapStub;
#import "TapManagerProtocol.h"
#import "VVSTap.h"


@interface VVRTap : NSObject {
	id						tapManager;
	NSString					*lastSelectedTapName;
	VVRTapStub				*stub;
	id						delegate;
}

//- (void) deleteMe;
- (void) prepareToBeDeleted;

//	when a new tap is created, a notification is posted; all rTaps receive it, and it makes them reload the list of available source taps...
//- (void) reloadAvailableTapsNotification:(NSNotification *)note;
//	when i post a new tap notification, the tap manager tells me where it is...
- (void) setTapManager:(id)newManager;
//	received from many places; tells me what tap name i should use
- (void) useTapNamed:(NSString *)newTapName;

//- (void) layerNameChangedNotification:(NSNotification *)note;

- (NSSize) sourceSize;
- (void) updateTapSize;

- (NSString *) lastSelectedTapName;
- (void) setLastSelectedTapName:(NSString *)newName;

- (CIImage *) getCIImage;

- (VVRTapStub *) stub;
- (void) setStub:(VVRTapStub *) newStub;

- (id) tapManager;

- (id) delegate;
- (void) setDelegate:(id)n;

@end
