//
//  VVRTapMenuController.h
//  VVSliders
//
//  Created by bagheera on 4/13/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "GlobalKeys.h"
//#import <VVEssentials/VVEssentials.h>
#import "TapManagerProtocol.h"




@interface VVRTapMenuController : NSObject <VVSnapshotProtocol> {
	IBOutlet NSPopUpButton			*button;
	id							tapManager;
	id							myTarget;		//	this is what gets told of new tap name selections
	SEL							myAction;		//	this is the method of the target that gets called when a new tap name is chosen
	NSMenu						*localMenu;
	NSString						*lastSelectedName;
}

//- (NSMutableDictionary *) createSnapshot;
//- (void) loadSnapshot:(NSMutableDictionary *)snap;

- (void) setTapManager:(id)newManager;

- (IBAction) menuUsed:(id)sender;
- (void) bang;

- (void) prepareToBeDeleted;

- (void) startPresetRestoreNotification:(NSNotification *)note;
- (void) stopPresetRestoreNotification:(NSNotification *)note;
- (void) reloadAvailableTapsNotification:(NSNotification *)note;
- (void) reloadAvailableTapsMethod;

- (void) setMyTarget:(id)n;
- (void) setMyAction:(SEL)a;
- (void) setButton:(NSPopUpButton *)n;

- (NSString *) lastSelectedName;
- (NSMenu *) localMenu;

@end
