//
//  VVSMDSListController.h
//  VDMX
//
//  Created by bagheera on 5/15/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVSliderManager.h"
@class VVSliderManager;
#import "DataSourceController.h"
@class DataSourceController;
//#import "FirstResponderTextField.h"
#import "RandomUIObjects.h"



@interface VVSMDSListController : NSObject {
	//IBOutlet NSOutlineView			*outlineView;
	//IBOutlet NSTableColumn			*dataSourceTableColumn;
	IBOutlet VVNSPopUpButton			*sourcePopUpButton;
	IBOutlet VVSliderManager			*sliderManager;
	IBOutlet DataSourceController		*dataSourceController;
	BOOL							acknowledgeSelectionChange;	//	if YES, then changes to the list's selection affect the currently selected slider(s)
	IBOutlet FirstResponderTextField	*dataSourceNameTextField;
}

//- (id) outlineView:(NSOutlineView *)view child:(int)index ofItem:(id)item;
//- (BOOL) outlineView:(NSOutlineView *)view isItemExpandable:(id)item;
//- (int) outlineView:(NSOutlineView *)view numberOfChildrenOfItem:(id)item;
//- (id) outlineView:(NSOutlineView *)view objectValueForTableColumn:(NSTableColumn *)column byItem:(id)item;

//- (void) outlineViewSelectionIsChanging:(NSNotification *)note;
//- (void) outlineViewSelectionDidChange:(NSNotification *)note;

- (void) selectItemForSourceArray:(NSArray *)a;
- (void) deselectAllItemsInMenu:(NSMenu *)m;
- (BOOL) selectItemForSourceString:(NSString *)s inMenu:(NSMenu *)m;
- (IBAction) sourcePopUpButtonUsed:(id)sender;
- (IBAction) dataSourceTextFieldUsed:(id)sender;

- (void) reloadView;
- (void) prepRawMenu:(NSMenu *)m;

- (BOOL) acknowledgeSelectionChange;
- (void) setAcknowledgeSelectionChange:(BOOL)newValue;

//- (void) sourcesChangedNotification:(NSNotification *)note;
- (void) reloadDSContextualMenu;

@end
