//
//  VVSMInterfaceManager.h
//  VDMX
//
//  Created by bagheera on 5/15/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "VVSliderManager.h"
//@class VVSliderManager;
#import "VVButtonManager.h"
//#import "VVNSPopUpButton.h"
//#import "VVNSTabView.h"
#import "RandomUIObjects.h"


@interface VVSMInterfaceManager : NSObject {
	IBOutlet VVButton			*addRemoveMarkButton;
	IBOutlet VVButton			*lockUnlockMarksButton;
	IBOutlet VVButton			*syncToggle;
	IBOutlet VVButton			*behaviorToggle;
	IBOutlet VVButton			*midiDetectButton;
	IBOutlet VVButton			*oscDetectButton;
	IBOutlet VVButton			*showSyncToggleButton;
	IBOutlet VVButton			*showBehavToggleButton;
	//IBOutlet VVButton			*hardwareLearnButton;
	
	IBOutlet VVSliderManager		*sliderManager;
	IBOutlet id					buttonManager;
	//IBOutlet NSButton			*syncToggle;
	//IBOutlet NSButton			*behaviorToggle;
	//IBOutlet NSOutlineView		*sourceView;	//	the outline view of data sources
	//IBOutlet VVNSPopUpButton		*dataSourcePopUpButton;
	IBOutlet VVSMDSListController	*sourceViewController;	//	outlet to the outline view's controller; i have to disable selection-change-based actions sometimes...
	//IBOutlet NSOutlineView		*behaviorView;
	IBOutlet VVSMBehaviorListController	*behaviorViewController;
	IBOutlet NSTextField			*currentValField;
	
	IBOutlet id					dataSourceController;
	IBOutlet VVNSTabView		*inspectorTabView;
}

//	called by the VVSliderManager when the slider inspector's interface needs to be updated
- (void) updateWithLockedStatus:(BOOL)lockFlag;
//	called by stuff when the slider's value has changed, but the slider is otherwise untouched- otherwise, i get table views reloading every time something's updated...
- (void) updateValueRelatedOnly;

//	actual interface-interaction methods for the .nib
- (IBAction) syncToggleUsed:(id)sender;
- (IBAction) behaviorToggleUsed:(id)sender;
- (IBAction) midiDetectUsed:(id)sender;
- (IBAction) oscDetectUsed:(id)sender;
- (IBAction) currentValFieldUsed:(id)sender;
- (IBAction) addRemoveMarkButtonused:(id)sender;
- (IBAction) lockUnlockMarksButtonUsed:(id)sender;
- (IBAction) showSyncToggleUsed:(id)sender;
- (IBAction) showBehavToggleUsed:(id)sender;

//- (VVButton *) hardwareLearnButton;
- (VVButton *) syncToggle;
- (VVButton *) midiDetectButton;
- (VVButton *) oscDetectButton;


@end
