//
//  VVStringTexture.h
//  VDMX
//
//  Created by bagheera on 5/23/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <OpenGL/gl.h>
//#import <OpenGL/glext.h>
#import <OpenGL/OpenGL.h>
//#import <OpenGL/CGLContext.h>
#import <OpenGL/CGLMacro.h>


@interface VVStringTexture : NSObject {
	CGLContextObj			destContextObj;	//	the CGLContextObj where my texture is stored
	BOOL					textureExists;
	BOOL					textureNeedsDeletion;
	GLuint				texName;
	NSSize				generatedTexSize;	//	only set when 'texName' is created!
	BOOL					deleted;
	
	NSAttributedString		*attrString;
	//NSColor				*textColor;
	NSColor				*boxColor;
	NSColor				*frameColor;
}


+ (id) createWithAttrString:(NSAttributedString *)s inContext:(CGLContextObj)con boxColor:(NSColor *)bc frameColor:(NSColor *)fc;
- (id) initWithAttrString:(NSAttributedString *)s inContext:(CGLContextObj)con boxColor:(NSColor *)bc frameColor:(NSColor *)fc;

- (void) drawAtPoint:(NSPoint)p;

- (void) genTexture;
- (void) deleteTexture;
- (NSImage *) generateImage;


@end
